"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const option_1 = require("@reactive-js/option");
const react_1 = require("@reactive-js/react");
const observable_1 = require("@reactive-js/observable");
const pipe_1 = require("@reactive-js/pipe");
const react_2 = require("react");
const empty = {
    path: "",
    query: "",
    fragment: "",
};
const pairify = ([_, oldState], next) => oldState === empty ? [option_1.none, next] : [oldState, next];
exports.Router = function Router(props) {
    const { location, notFound, routes, scheduler } = props;
    const locationStore = react_1.useAsyncEnumerable(location, { replay: 1 });
    const observable = react_2.useMemo(() => {
        if (option_1.isNone(locationStore)) {
            return observable_1.never();
        }
        else {
            const routeMap = {};
            for (const [path, component] of routes) {
                routeMap[path] = component;
            }
            const uriUpdater = (updater) => {
                locationStore.dispatch(updater);
            };
            return pipe_1.pipe(locationStore, observable_1.scan(pairify, () => [option_1.none, empty]), observable_1.map(([referer, uri]) => {
                var _a;
                return react_2.createElement((_a = routeMap[uri.path]) !== null && _a !== void 0 ? _a : notFound, {
                    referer,
                    uri,
                    uriUpdater,
                });
            }));
        }
    }, [locationStore, notFound, routes]);
    const element = react_1.useObservable(observable, scheduler);
    return element !== null && element !== void 0 ? element : null;
};
//# sourceMappingURL=router.js.map