import { StateUpdater, AsyncEnumerableLike } from "@reactive-js/async-enumerable";
import { Option } from "@reactive-js/option";
import { SchedulerLike } from "@reactive-js/scheduler";
import { ReactElement } from "react";
export declare type RelativeURI = {
    readonly fragment: string;
    readonly path: string;
    readonly query: string;
};
export declare type RoutableComponentProps = {
    readonly referer: Option<RelativeURI>;
    readonly uri: RelativeURI;
    readonly uriUpdater: (updater: StateUpdater<RelativeURI>) => void;
};
export declare type RouterProps = {
    readonly location: AsyncEnumerableLike<StateUpdater<RelativeURI>, RelativeURI>;
    readonly notFound: React.ComponentType<RoutableComponentProps>;
    readonly routes: readonly [string, React.ComponentType<RoutableComponentProps>][];
    readonly scheduler?: SchedulerLike;
};
export declare const Router: (props: RouterProps) => ReactElement<any, string | ((props: any) => ReactElement<any, string | any | (new (props: any) => import("react").Component<any, any, any>)> | null) | (new (props: any) => import("react").Component<any, any, any>)> | null;
